/**
 * 
 */
package net.bigeon.gclc.process;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.io.IOException;

import org.junit.Test;

import net.bigeon.gclc.exception.CommandRunException;
import net.bigeon.gclc.exception.CommandRunExceptionType;
import net.bigeon.gclc.manager.PipedConsoleInput;
import net.bigeon.gclc.manager.PipedConsoleOutput;

/** @author Emmanuel Bigeon */
public class ForkTaskTest {

    @Test
    public void testGenericForkTask() throws IOException {

        // FIXME This test fail to complete on Jenkins.
        final ForkTask task = new ForkTask(5) {

            @Override
            public String getName() {
                return "name";
            }

            @Override
            protected void doRun() throws CommandRunException {
                String msg;
                try {
                    msg = in.prompt();
                } catch (final IOException e) {
                    throw new CommandRunException(CommandRunExceptionType.INTERACTION,
                            "Unable to prompt user");
                }
                out.println(msg);
            }
        };

        final Thread execThread = new Thread(task, "Task");
        execThread.start();
        try {
            execThread.join(100);
        } catch (final InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        try (PipedConsoleOutput pco = new PipedConsoleOutput();
                PipedConsoleInput pci = new PipedConsoleInput(null)) {
            while (!pco.available()) {
                pci.type("ok");
                task.join(pco, pci, 1000);
            }
            assertEquals("Positive execution", "ok", pco.readNextLine());
        }
        assertFalse("Running state should be updated by task on its completion",
                task.isRunning());
    }

}
